
// compilation command:
//   clang++ -o ex-race ex-race.cc -lpthread

#include <thread>
#include <stdio.h>
#include <assert.h>

int x = 0;

void foo()
{
    while (true)
    {
        x = x + 1;
        x = x - 1;
        printf("x=%d\n", x);  // should print 0 when no races on x 
    }
}

int main()
{
    std::thread t1(foo);
    std::thread t2(foo);

    t1.join();
    t2.join();
}
